// Description: 
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.FreeOTFE.org/
//
// -----------------------------------------------------------------------------
//


#ifndef _FreeOTFECypherAES_Gladman_H
#define _FreeOTFECypherAES_Gladman_H   1

#include <initguid.h>  // Required for DEFINE_GUID macro

// =========================================================================
// Const definitions

// These values are in DECIMAL
#define DRIVER_CYPHER_IMPL_VERSION_MAJOR     01
#define DRIVER_CYPHER_IMPL_VERSION_MINOR     00
#define DRIVER_CYPHER_IMPL_VERSION_BUILD   0000

#define DRIVER_CYPHER_IMPL_VERSION  (                                      \
                         (DRIVER_CYPHER_IMPL_VERSION_MAJOR * 0x01000000) + \
                         (DRIVER_CYPHER_IMPL_VERSION_MINOR * 0x00010000) + \
                         (DRIVER_CYPHER_IMPL_VERSION_BUILD * 0x00000001)   \
                        )


#define CYPHERS_SUPPORTED   3

// NOTE: ASCII, not WCHAR
#define DRIVER_TITLE                 "AES (Gladman library)"
DEFINE_GUID(DRIVER_GUID,         0x00000000L, 0x0000, 0x0000, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0D, 0x00, 0x01);

// NOTE: ASCII, not WCHAR
#define DRIVER_CIPHER_TITLE_AES_128  "AES"
DEFINE_GUID(CIPHER_GUID_AES_128, 0x00000000L, 0x0000, 0x0000, 0x00, 0x00, 0x00, 0x00, 0x0D, 0x00, 0x00, 0x02);

#define DRIVER_CIPHER_TITLE_AES_192  "AES"
DEFINE_GUID(CIPHER_GUID_AES_192, 0x00000000L, 0x0000, 0x0000, 0x00, 0x00, 0x00, 0x00, 0x0D, 0x00, 0x00, 0x04);

#define DRIVER_CIPHER_TITLE_AES_256  "AES"
DEFINE_GUID(CIPHER_GUID_AES_256, 0x00000000L, 0x0000, 0x0000, 0x00, 0x00, 0x00, 0x00, 0x0D, 0x00, 0x00, 0x05);


// =========================================================================
// Various internal functions

#define AES_BLOCK_SIZE 128

// =========================================================================

#endif

